'BootableUSB.vbs v 2.0
'Check for Windows version
'UAC message
'List all USB drives
'Create and run diskpart script

set oshell = createobject("wscript.shell")
if left(oshell.regRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\CurrentVersion"),1) < 6 then
	msgbox "Sorry- this script uses diskpart features only available in Window Vista and later.",,"Unsupported O/S"
	wscript.quit
end if

 
If WScript.Arguments.length =0 Then
	msgbox "This program must be run as administrator!" & vbcrlf & vbcrlf & _
		"Select 'YES' when the User Account Control displays.",,"User Account Control Warning"

	Set objShell = CreateObject("Shell.Application")
	objShell.ShellExecute "wscript.exe", Chr(34) & _
	WScript.ScriptFullName & Chr(34) & " uac", "", "runas", 1
Else

	filespec = replace(Wscript.ScriptFullName,Wscript.ScriptName,"input.txt")


	strComputer = "."
	Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
	Set colUsbDrives = objWMIService.ExecQuery("SELECT * FROM Win32_DiskDrive where InterfaceType='USB'")
	Set objDictionary = CreateObject("Scripting.Dictionary")
	set oShell = CreateObject("wscript.shell")


	'enumerate USB drives and add to dictionary object
	EnumerateDrives


	if objDictionary.count<1 then
		msgbox "No USB drives available. Plug a USB drive into this computer and start again."
		wscript.quit
	end if


	'list of USB drives: DeviceID, Letter, Caption, Size
	dim strDrives
	strDrives = "ID" & vbtab & "Drive" & vbtab & "Desc" & vbcrlf & "=====" & vbtab & "=====" & vbtab & "======"
	For Each strItem in objDictionary.Items
			strDrives = strDrives & vbcrlf & strItem.deviceIDx  & vbtab & strItem.letter & vbtab & left(strItem.caption,28) 
	Next
	

	'Loop until user selects to format a valid drive or cancels...
	dim bGo, intError
	intError =0
	bGo = "X"
	do while bGo = "X"
		strDriveIDx = inputbox(strDrives & vbcrlf & vbcrlf & "Type a drive ID number from the list, or Cancel to quit.", "Select Drive ID...") '"======SELECT A DEVICE ==========" & vbcrlf & "Type a DRIVE ID NUMBER, or type 'Q' to quit","Select Device To Format")
		if (strDriveIDx="") then
			msgbox "Goodbye!"
			wscript.quit
		end if
		if isSelectedDriveExist(strDriveIDx) then
			if isConfirmFormat(strDriveIDx) then
				'create text of diskpart script
				strScript = createScriptData(strDriveIDx, objDictionary.item(strDriveIDx).Letter, "UsbBoot", "fat32")
				intError = writeScriptToFile (strScript)
				if intError<>0 then
					msgbox "Error occurred creating diskpart script file. Error number: " & intError
					wscript.quit
				end if
				intError = 0
				
				intError = StartDiskPart()
				if intError<>0 then
					msgbox "Error occurred on diskpart operation. Error number: " & intError
					wscript.quit
				end if
				
				msgbox SummaryText(strDriveIDx),,"SCRIPT COMPLETED"
				bGo=true
			else
				if msgbox ("Do you want to quit?",4,"EXIT SCRIPT") = 6 then ' 6 yes
					msgbox "Goodbye!"
					wscript.quit
				end if
			end if
		else
			msgbox "Invalid entry."
		end if
	loop
End if


'create myDriveClass
'myDriveClass. deviceIDx, deviceID, caption, size, interface, letter
Class myDriveClass
	public DeviceIdDriveLetter
	public DeviceIDx
	public DeviceID
	public Caption
	public Size
	public InterfaceType
	public Letter
end Class


function StartDiskPart ()
	StartDiskPart = oShell.run ("diskpart.exe /s " & chr(34) & fileSpec & chr(34),1,true)
end function


function isSelectedDriveExist(strDriveIDx)
	if objDictionary.exists(strDriveIDx) then
		isSelectedDriveExist=true
	else
		isSelectedDriveExist=false
	end if

end function

function SummaryText(strDriveIDx)
	SummaryText = "Operation completed!" & vbcrlf & vbcrlf &_
		"ID" & vbtab & "Drive" & vbtab & "Size" & vbcrlf & "==" & vbtab & "====" & vbtab & "=====" & vbcrlf &_
		strDriveIDx & vbTab & objDictionary.item(strDriveIDx).Letter & vbTab & objDictionary.item(strDriveIDx).Size & vbCrlf &_ 
		objDictionary.item(strDriveIDx).Caption & vbcrlf & vbcrlf &_
		"You can use the xcopy command to copy operating system files to USB drive.  Example: xcopy *.* /s/e/f " & objDictionary.item(strDriveIDx).Letter & "\"

end function


function isConfirmFormat(strDriveIDx)
	returnVal = msgbox ("This will format the USB drive. All data on this USB will be deleted." & vbcrlf & vbcrlf &_
		"ID" & vbtab & "Drive" & vbtab & "Size" & vbTab & "Desc" & vbcrlf & "=====" & vbtab & "=====" & vbtab & "=====" & vbtab & "=====" & vbcrlf &_
		strDriveIDx & vbTab & objDictionary.item(strDriveIDx).Letter & vbTab & objDictionary.item(strDriveIDx).Size & vbTab & objDictionary.item(strDriveIDx).caption & vbCrlf & vbCrlf &_ 
		"Do you want to continue?" ,4, "FORMAT DRIVE CONFIRMATION")
	if returnVal = 6 then
		isConfirmFormat=true
	else
		isConfirmFormat = false
	end if
end function


'Create diskpart script
function writeScriptToFile(scriptData)
	on error resume next
    set fso = createobject("scripting.fileSystemObject")
    set ofile = fso.CreateTextFile(fileSpec,true)
    ofile.write scriptData
    ofile.close
	
	writeScriptToFile = err.Number	
end function


function createScriptData (DeviceID, driveLetter, partitionLabel, fileSystem) 'filesystem = fat32
    data="select disk " & DeviceID
    data = data & vbCrLf & "clean"
    data = data & vbCrLf & "create partition primary"
    data = data & vbCrLf & "assign letter=" & driveLetter
    data = data & vbCrLf & "active"
    data = data & vbCrLf & "format fs=" & fileSystem & " label=" & partitionLabel

    createScriptData = data
end function


Sub EnumerateDrives
	for each oDrive in colUsbDrives
		set oMyDriveClass = new myDriveClass
		oMyDriveClass.DeviceIdDriveLetter = Replace(oDrive.DeviceID, "\", "\\")
		oMyDriveClass.deviceIDx = right(oDrive.DeviceID,1)
		oMyDriveClass.DeviceID = oDrive.DeviceID
		oMyDriveClass.Caption = oDrive.Caption
		oMyDriveClass.size = ConvertNumber(oDrive.size)
		oMyDriveClass.InterfaceType = oDrive.InterfaceType
		oMyDriveClass.Letter = GetDriveLetterOfDeviceID (oMyDriveClass.DeviceIdDriveLetter)
		
		objDictionary.Add oMyDriveClass.DeviceIDx, oMyDriveClass
	next
End Sub
	
	
function GetDriveLetterOfDeviceID (strDeviceID)
	Set colPartitions = objWMIService.ExecQuery ("ASSOCIATORS OF {Win32_DiskDrive.DeviceID=""" & strDeviceID & """} WHERE AssocClass = " & "Win32_DiskDriveToDiskPartition")

	For Each objPartition In colPartitions
		Set colLogicalDisks = objWMIService.ExecQuery("ASSOCIATORS OF {Win32_DiskPartition.DeviceID=""" & objPartition.DeviceID & """} WHERE AssocClass = " & "Win32_LogicalDiskToPartition")
		For Each objLogicalDisk In colLogicalDisks
			TargetPath = objLogicalDisk.DeviceID
		Next
	Next
	
	GetDriveLetterOfDeviceID = TargetPath
end function
	

Function ConvertNumber(iValue)
    lValue = len(iValue)

    Select case lValue
        case  1,2,3
            ConvertNumber = iValue & "Bytes"
        case  4,5,6
            ConvertNumber = round(iValue/1024,2) & "Kb"
        case 7,8,9
            ConvertNumber = round((iValue/1024)/1024,2) & "MB"
        case else
            ConvertNumber = round(((iValue/1024)/1024)/1024,2) & "GB"
    end select
End function